#!/usr/bin/python3
# encoding: latin-1

try:
    import pyext
except:
    print "ERROR: This script must be loaded by the PD/Max pyext external"

import numpy as np
import pickle
import sys

# Uncomment this if you want to try with PyQt4 dialogs.
#~ from PyQt4 import QtCore, QtGui

              
class DataManager(pyext._class):
    
        # number of inlets and outlets
    def __init__(self):

        self._inlets = 1
        self._outlets = 1
        self.buffersNames = dict()        
        self.buffersData = dict()
        self.filename = None
        self.verbose = False
        self._detach(1)
        return None
        
    def verbose_1(self):
        self.verbose = not(self.verbose)
        if self.verbose: 
            print "Verbose mode is on."
        else:
            print "Verbose mode is off."
        return None
    
    def setBuffer_1(self, d0, d1, d2):

        self.buffersNames[(str(d0),str(d1))] = str(d2)      # this is key to reload the array.
        if self.verbose:
            print "  -----  "
            print "Instance Id ($1): ", d0,", buffer #:",d1, ", ", "abstraction name ($0):", d2
            print 
            print "Buffer key names dictionary is now: "
            for key,value in self.buffersNames.items():
                print key,":",value
        
        return None
    
    # Uncomment this if you want to try with PyQt4 dialogs.
    #~ def setFilenameDialog_1(self):
        
        #~ app = QtGui.QApplication(sys.argv)
        #~ filename = QtGui.QFileDialog.getSaveFileName(caption = QtCore.QString("Choose filename session name"), selectedFilter=QtCore.QString(".pddata") )
        #~ self.setFilename_1(str(filename))
        #~ return None
        
        
    def setFilename_1(self, filename):
        
        if (filename != None) and (filename != ""):
            self.filename = str(filename)
            if self.verbose:
                print "Filename set: ",self.filename
        else:
            if self.verbose:
                print "Filename not set."
        
        return None
        
        
    def saveData_1(self):
        
        if self.filename != None:
            for key,value in self.buffersNames.items():
                
                buffer = value+"-"+key[1]
                
                if self.verbose:
                    print "key :", key,",  buffer: ", buffer
                aux = pyext.Buffer(pyext.Symbol(buffer))           
                
                lena = len(aux)
                data = np.zeros(lena, dtype = np.float32)
                
                for I in range(lena):
                    data[I] = aux[I]
                    
                self.buffersData[key] = data       
                if self.verbose:
                    print "data: ",data
                
            
            # pickle and save to disk
            file = open(self.filename, "wb")
            P = pickle.Pickler(file, protocol=2)
            status = P.dump(self.buffersData)
            file.close()
            print "Data saved."
            self._outlet(1,pyext.Symbol("bang"))
            
        else:
            print "Filename not set."

        return None
        
        
    def loadData_1(self):
        
        if self.filename != None:
            try:
                file = open(self.filename, "rb")
            except:
                print "Error in opening file."
                return None                
            try:
                U = pickle.Unpickler(file)                
                data = U.load()
                
            except:
                print "Error in unpickling file."
                return None
                            
            for key,values in data.items():
                print key

            for key,values in data.items():
                
                if key in self.buffersNames.keys():
                    
                    array = self.buffersNames[key]+"-"+key[1]
                    if self.verbose:
                        print "buffer array:",array, ",  buffer:",key,
                    try:
                        a = pyext.Buffer(pyext.Symbol(array))
                        if self.verbose:
                            print " values:", a
                        
                        lena = len(a)
                        
                        aux = np.array(values, dtype=np.float32)
                        a[:lena] = aux[:lena]
                        if self.verbose:
                            print "Buffer ", key, " set."    
                    except:
                        print "Error in loading data for array/table: ", array                        
                else:
                    print "Buffer name not set for ", key
                    
            return None
        else:
            print "File name not set. "
                
        
    def bang_1(self):

        print pyext.Symbol("Ouch, I received a bang.")
        
        return None 
